unit frmQDSQLUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, Db, ADODB, ADOConed,StdCtrls, CheckLst, ComCtrls, ExtCtrls, Grids,
  DBGrids, Buttons, Menus;

type
  TfrmQDSQL = class(TForm)
    Panel1: TPanel;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ImageList1: TImageList;
    lbTables: TListBox;
    lbFields: TListBox;
    lbJoins: TListBox;
    TabSheet4: TTabSheet;
    lbSort: TCheckListBox;
    Label1: TLabel;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    DBGrid1: TDBGrid;
    mSQL: TMemo;
    Panel5: TPanel;
    btnGenSQL: TBitBtn;
    Splitter2: TSplitter;
    lbWhere: TStringGrid;
    btnTestSQL: TBitBtn;
    ADOQuery1: TADOQuery;
    DataSource1: TDataSource;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    btnNew: TBitBtn;
    MainMenu1: TMainMenu;
    Files1: TMenuItem;
    Help1: TMenuItem;
    SaveSQLAs1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ADOConnection1: TADOConnection;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    OpenDataconnection1: TMenuItem;
    procedure ADOConnection1AfterConnect(Sender: TObject);
    procedure TreeView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure lbTablesStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbTablesDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbTablesDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormActivate(Sender: TObject);
    procedure lbFieldsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbFieldsStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure lbFieldsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbFieldsDblClick(Sender: TObject);
    procedure StringGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Panel4DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbJoinsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbJoinsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbSortDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbSortDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure btnGenSQLClick(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbWhereDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbWhereDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure btnTestSQLClick(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure lbWhereExit(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure SaveSQLAs1Click(Sender: TObject);
    procedure OpenDataconnection1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Procedure DeleteRowFromStrGrid(rowindex:Integer);

  public
    { Public declarations }
  end;

var
  frmQDSQL: TfrmQDSQL;

implementation



{$R *.DFM}
Procedure TfrmQDSQL.DeleteRowFromStrGrid(rowindex:Integer);
var i, j : INteger;
begin
        if rowIndex <= 0 then abort;

        // last row
        if (rowIndex = lbWhere.RowCount -1) then
                begin
                   lbWhere.RowCount := lbWhere.RowCount -1;
                   abort;
                end;

        for i := rowIndex to lbWhere.RowCount - 2 do begin
             for j := 0 to 3 do begin
                   lbWhere.Cells[j,i] :=
                      lbWhere.Cells[j,i + 1]
             end;
        end;
        lbWhere.RowCount := lbWhere.RowCount - 1;
        
end;

procedure TfrmQDSQL.ADOConnection1AfterConnect(Sender: TObject);
var i1, i2 : Integer;
     w : WideString;
begin
      ADOConnection1.GetTableNames (lbTables.Items,false);
      w := ADOConnection1.ConnectionString ;
      i1 := 0;
      i2 := 0;
      i1 := Pos('Data Source=',w);
      if i1 > 0 then
        begin

        w := copy(w,i1 ,length(w));
        i1 := pos(';',w);
        end;
      if i1 = 0 then
      Self.Caption := 'Q&D SQL Builder is Connected to Database!'
      else
      Self.Caption := copy(w,1,i1-1);
       

end;

procedure TfrmQDSQL.TreeView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
     // Start drag
end;

procedure TfrmQDSQL.lbTablesStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
// Start drag
end;

procedure TfrmQDSQL.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);

  begin
       if (source is TStringGrid) then
        Accept := true;

  //ShowMessage(s);


end;

procedure TfrmQDSQL.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
  var s : String;
      node, Node2 : TTReeNode;
      i : Integer;
      t : TStringList;
begin

  //s := Sender.ClassName + ', ' + Source.ClassName ;
  //ShowMessage(s);
     if (source is TStringGrid) then
                   begin
                     i := (source as TStringGrid).Row;

                     DeleteRowFromStrGrid (i);
                   end;

        if (source is TListBox) then
           begin

                if ((source as TlistBox).name = 'lbJoins') then
                   begin
                      i := (source as TlistBox).ItemIndex;
                      if i >= 0 then
                         (source as TlistBox).Items.Delete (i);
                   end;

               if ((source as TListBox).name = 'lbSort') then
                   begin
                      i := (source as TListBox).ItemIndex;
                      if i >= 0 then
                         (source as TListBox).Items.Delete (i);
                   end;



               if ((source as TlistBox).name = 'lbFields') then
                   begin
                      i := (source as TlistBox).ItemIndex;
                      if i >= 0 then
                         (source as TlistBox).Items.Delete (i);

                   end;



               if ((source as TlistBox).name = 'lbTables') then
                   begin
                     i := (source as TlistBox).ItemIndex;

                     with TreeView1.Items do begin
                           // add node
                           node := add(nil,(source as TlistBox).Items[i]);
                           // Delete Field from Selections
                           (source as TlistBox).Items.Delete (i);
                           Node.ImageIndex := 1;
                           // add Children (fields);

                            t := TStringList.Create ;
                            try
                             ADOConnection1.GetFieldNames(node.text,t);
                             for i := 0 to t.Count - 1 do begin
                              Node2 := AddChild (node,t[i]);
                              Node2.ImageIndex := 2;

                             end;


                            finally
                            t.free
                            end;

                       TreeView1Change (Sender,nil);

                     end;
                   end;

           end;



end;

procedure TfrmQDSQL.lbTablesDragDrop(Sender, Source: TObject; X, Y: Integer);
var node : TTreeNode;
begin

      //  ShowMessage('Drop');

        if (source is TTreeview) then
          begin
             node :=  (source as TTreeview).selected;
             if node <> nil then begin

                if node.Level = 0 then
                   begin
                      lbTables.Items.Add(node.text);

                      lbTables.ItemIndex :=
                        lbTables.Items.IndexOf(node.text);

                      (source as TTreeView).Items.Delete (node);

                   end;
             end;
          end;


end;

procedure TfrmQDSQL.lbTablesDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
      // test
end;

procedure TfrmQDSQL.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin

       Tabsheet2.Tabvisible := (TreeView1.Items.Count > 0);
        Tabsheet3.Tabvisible := (TreeView1.Items.Count > 0);



end;

procedure TfrmQDSQL.FormActivate(Sender: TObject);
begin
        if not(ADOConnection1.connected) then
             begin
                //MessageDlg('There is no data connection.'+#13+#10+''+#13+#10+'You can create on from the FILE menu ', mtWarning, [mbOK], 0);
                Self.Caption := 'Q&D SQL Builder - Not Connected! Use File|Open menu';
             end;
         


        TreeView1Change (Sender,nil);
end;

procedure TfrmQDSQL.lbFieldsDragDrop(Sender, Source: TObject; X, Y: Integer);
var node : TTreeNode;
     s : String;
begin

      //  ShowMessage('Drop');

        if (source is TTreeview) then
          begin
             node :=  (source as TTreeview).selected;
             if node <> nil then begin
                s := '';
                Case Node.Level of
                0 : s := '[' + node.text + '].*';
                1 : s :=  '[' + node.Parent.text + '].[' +
                             node.text + ']';

                end;
                if (s <> '') then
                  begin
                     if lbFields.Items.IndexOf (s) < 0  then
                        lbFields.Items.Add(s);

                  end;


             end;
           end;


end;

procedure TfrmQDSQL.lbFieldsStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
 // test
end;

procedure TfrmQDSQL.lbFieldsDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  // test
end;
procedure TfrmQDSQL.lbFieldsDblClick(Sender: TObject);
var i : Integer;
begin

     i := lbFields.ItemIndex;
     if i >= 0 then
        lbFields.Items.delete(i);
        


end;

procedure TfrmQDSQL.StringGrid1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  // 
end;

procedure TfrmQDSQL.Panel4DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
        if (source is TTreeview) then
                Accept := true;


end;

procedure TfrmQDSQL.lbJoinsDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
       if (source is TTreeview) then
           Accept := true;
end;

procedure TfrmQDSQL.lbJoinsDragDrop(Sender, Source: TObject; X, Y: Integer);
var fl, fr : String;
     i : Integer;
     node : TTreeNode;
begin

        if (source is TTreeview) then
                begin
                  node := (source as TTreeView).Selected ;
                  // if there is a valid selected node
                  if (node <> nil) then
                     // make sure it's a field
                     if (node.level = 1) then
                        begin
                          fl := '[' + node.parent.text + '].[' +
                                   node.text + ']';

                          if lbJoins.Items.count = 0 then
                                // list of joins is empty, so add first item
                                lbJoins.Items.add(fl)
                             else
                                begin
                                  // there are items in the list
                                   i :=  lbJoins.Items.count -1;
                                   fr := lbJoins.Items[i];

                                   if pos('=',fr) > 0 then
                                      //  '=' designates line is complete, so start next item
                                      lbJoins.Items.add(fl)
                                    else
                                      // otherwise concate
                                      lbJoins.Items[i] := fr + ' = ' + fl;

                                end;






                        end;
                end;




end;

procedure TfrmQDSQL.lbSortDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
        if (source is TTReeview) then
            accept := true;



end;

procedure TfrmQDSQL.lbSortDragDrop(Sender, Source: TObject; X, Y: Integer);
var Node : TTreeNode;
begin
        if (source is TTreeview) then
                begin
                  node := (source as TTreeView).Selected ;
                  // if there is a valid selected node
                  if (node <> nil) then
                     // make sure it's a field
                     if (node.level = 1) then
                          lbSort.Items.add('[' + node.parent.text + '].[' +
                                   node.text + ']');
                end;



end;

procedure TfrmQDSQL.btnGenSQLClick(Sender: TObject);
var i : Integer;
    s, s1 : String;
    Node : TTreeNode;
begin
        // generate SQL
         mSQL.Clear;

        // fields
        if CheckBox1.Checked then
           mSQL.Lines.Add('SELECT DISTINCT')
         else
             mSQL.Lines.Add('SELECT ');
             
           for i := 0 to lbFields.Items.Count - 1 do begin
             s := '';
             if i < (lbFields.Items.Count - 1) then
                s := ',';

                mSQL.Lines.Add('  ' + lbFields.Items[i] + s);

           end;

         // FROM
           s := '';
          for i := 0 to TreeView1.Items.count - 1 do begin
              node :=  TreeView1.Items[i];

              if (node <> nil) then
                 begin
                    if node.Level = 0 then
                       if (s = '') then
                          s := '[' + node.text + ']'
                         else
                          s := s + ', ' +'[' + node.text + ']';

                 end;
          end;
          mSQL.Lines.Add('FROM ' + s);

          //Joins

          if  ((lbJoins.Items.count > 0) or
                (lbWhere.RowCount > 1) ) then
                  mSQL.Lines.Add('WHERE (' );

          for i := 0 to lbJoins.Items.count - 1 do begin
                s := '';
                if i < (lbJoins.Items.count - 1) THEN
                    s := ' AND ';
                 mSQL.Lines.add( '(' + lbJoins.Items[i] + ')' + s);

           end;

           if  (lbJoins.Items.count > 0) and (lbwhere.RowCount > 1) then
             mSQL.Lines.Add('AND ');

           for i := 1 to lbWhere.rowCount -1 do
             begin
               s := '';
                mSQL.Lines.Add('(' +
                  lbWhere.Cells[0,i] + lbWhere.Cells[1,i] +
                  lbWhere.Cells[2,i] + ')' + lbWhere.Cells[3,i]);

             end;



          if  ((lbJoins.Items.count > 0) or
                (lbWhere.RowCount > 1) ) then
                  mSQL.Lines.Add(')' );

           s := '';
           if lbSort.Items.Count > 0 then
                begin

                  s := 'ORDER BY ' ;
                  for i := 0 to lbSort.items.count -1 do begin
                     s1 := '';
                     if lbsort.Checked[i] then
                        s1 := ' DESC';

                     if i = 0 then
                        s := s + lbSort.items[i] + s1
                      else
                        s := s + ', ' + lbSort.items[i] + s1;
                    end;
                  mSql.Lines.Add(s);
                end;



end;

procedure TfrmQDSQL.ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
        if (source is TTreeView) then
                accept := true;


end;

procedure TfrmQDSQL.lbWhereDragDrop(Sender, Source: TObject; X, Y: Integer);
var node : TTReeNode;
  var //t : TdlgSQLWhere;
      i : INteger;
begin
        if (source is TTreeview) then
                begin
                  node := (source as TTreeView).Selected ;
                  // if there is a valid selected node
                  if (node <> nil) then
                     // make sure it's a field
                     if (node.level = 1) then
                          begin
                             if lbWhere.RowCount >= 1 then
                                 begin
                                   i :=  lbWhere.RowCount ;
                                   lbWhere.RowCount := i + 1;
                                   lbWhere.FixedRows := 1;
                                   lbWhere.Cells [0,i] :=
                                                '[' + node.Parent.text + '].[' +
                                                 node.text + ']';

                                   lbWhere.Cells[1,i] := '=';
                                   lbWhere.SetFocus;
                                   lbWhere.Row := i ;
                                   lbWhere.Col := 2;


                                   lbWhere.Cells[0,0] := 'Field';
                                   lbWhere.Cells[1,0] := 'Equate';
                                   lbWhere.Cells[2,0] := 'Criteria';
                                   lbWhere.Cells[3,0] := 'AND/OR';

                                   if (i > 1) then
                                       if (lbWhere.cells[3, i-1] = '') then
                                            lbWhere.cells[3, i-1] := 'AND';



                                   end
                                 else
                                   begin


                                   end;
                           end;
                end;

end;

procedure TfrmQDSQL.lbWhereDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
        if (source is TTReeView) then
                accept := true;

       

end;

procedure TfrmQDSQL.btnTestSQLClick(Sender: TObject);
begin
        Screen.Cursor := crSQLWait;
        ADOQuery1.CLose;

        try
         ADOQuery1.SQL.Assign(mSQL.Lines);
         ADOQuery1.Open
        except
         on E: Exception DO ShowMessage( E.Message);

        end;
        Screen.Cursor := crDefault;

end;

procedure TfrmQDSQL.Panel1Resize(Sender: TObject);
var l : INteger;
begin
      l := Splitter1.left + splitter1.Width ;
      btnNew.Left := l;


      l := Panel1.Width - BitBtn2.Width - 12;



      if l > (btnNew.Left + btnNew.Width) then
                BitBtn2.Left := l;

end;

procedure TfrmQDSQL.lbWhereExit(Sender: TObject);
var i : INteger;
begin

       

end;

procedure TfrmQDSQL.Splitter1Moved(Sender: TObject);
begin
    Panel1Resize (sender);
end;

procedure TfrmQDSQL.btnNewClick(Sender: TObject);
begin

    ADOConnection1.Close;
    TreeView1.Items.Clear ;
    lbFields.clear;
    lbJoins.Clear;
    lbSort.Clear;
    lbWhere.RowCount := 1;
    mSQL.clear;
    ADOConnection1.Open;


end;

procedure TfrmQDSQL.SaveSQLAs1Click(Sender: TObject);
begin
    with SaveDialog1 do begin
           DefaultExt := 'TXT';
           Filter := 'Q & D SQL Design|*.TXT';
           if Execute then
              begin
               try
                 mSQL.Lines.SaveToFile (filename);
               except
                 on e: Exception do ShowMessage(E.Message);
               end;


              end;

      end;

end;

procedure TfrmQDSQL.OpenDataconnection1Click(Sender: TObject);
begin
          if ADOConnection1.Connected then
             ADOConnection1.close;


                   try
                     EditConnectionString (ADOConnection1);
                     Screen.Cursor := crHourglass;
                     ADOConnection1.Open
                   except
                      on E: Exception DO ShowMessage(e.message);
                   end;
                    Screen.Cursor := crDefault;

end;

procedure TfrmQDSQL.FormCreate(Sender: TObject);
begin
     PageControl1.ActivePageINdex := 0
end;

end.



